#ifdef USE_TAG_RESERVE

/* Actually use the tag reserve function */

#define TAG_RESERVE(x) mfc_tag_reserve()
#define TAG_ASSERT(t, x) assert( ( (t) >= 0 ) && ( (t) < 32 ) )

#else

/* Set tag to a given value */

#define TAG_RESERVE(x) x
#define TAG_ASSERT(t, x) assert( (t) == x )

#endif


/* --------------------------------------------------------------  */
/* (C)Copyright 2001,2007,                                         */
/* International Business Machines Corporation,                    */
/* Sony Computer Entertainment, Incorporated,                      */
/* Toshiba Corporation,                                            */
/*                                                                 */
/* All Rights Reserved.                                            */
/*                                                                 */
/* Redistribution and use in source and binary forms, with or      */
/* without modification, are permitted provided that the           */
/* following conditions are met:                                   */
/*                                                                 */
/* - Redistributions of source code must retain the above copyright*/
/*   notice, this list of conditions and the following disclaimer. */
/*                                                                 */
/* - Redistributions in binary form must reproduce the above       */
/*   copyright notice, this list of conditions and the following   */
/*   disclaimer in the documentation and/or other materials        */
/*   provided with the distribution.                               */
/*                                                                 */
/* - Neither the name of IBM Corporation nor the names of its      */
/*   contributors may be used to endorse or promote products       */
/*   derived from this software without specific prior written     */
/*   permission.                                                   */
/*                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
/* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
/* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
/* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */
#include "../euler.h"

typedef struct {
  int particles;	// number of particle to process
  void /*vector float*/ *pos_v;	// pointer to array of positions vectors
  void /*vector float*/ *vel_v;	// pointer to array of velocity vectors
  float *inv_mass;	// pointer to array of mass vectors
  /*vector float force_v;*/	// force vector
  float dt;		// current step in time
} parm_context;

#define HAVOC_CONTEXT(c) \
  c.particles = __CPROVER_ndet_int(); \
  c.pos_v = __CPROVER_ndet_int(); \
  c.vel_v = __CPROVER_ndet_int(); \
  c.inv_mass = __CROVER_ndet_int(); \
  c.dt = __CPROVER_ndet_int();
